import django_filters as filters
from django_filters import CharFilter, ModelChoiceFilter
from .models import Score
from users.models import Person
from django.db.models import Q
# from django.forms.widgets import TextInput

class ScoreFilter(filters.FilterSet):
    # semester = CharFilter(field_name='semester__semester', lookup_expr='icontains', label="Semester")
    course = CharFilter(field_name='course__course_code', lookup_expr='icontains', label="Course")
    undergrad = CharFilter(field_name='undergrad__username', lookup_expr='icontains', label="Matric")
    class Meta:
        model = Score
        fields = ['semester']
    # def __init__(self, *args, **kwargs):
    #     super(RegisteredCourseUnderGradFilter, self).__init__(*args, **kwargs)
    #     self.filters['course__course_code'].label="Course Code"
    #     self.filters['undergrad__username'].label="Matric Number"

class ScoreFilterUndergrad(filters.FilterSet):
    semester = CharFilter(field_name='semester__semester', lookup_expr='icontains', label="Semester")
    course = CharFilter(field_name='course__course_code', lookup_expr='icontains', label="Course Code")
    class Meta:
        model = Score
        fields = []

class ScoreFilterHoD(filters.FilterSet):
    # semester = CharFilter(field_name='semester__semester', lookup_expr='icontains', label="Semester")
    course = CharFilter(field_name='course__course_code', lookup_expr='icontains', label="Course")
    undergrad = CharFilter(field_name='undergrad__username', lookup_expr='icontains', label="Matric")
    class Meta:
        model = Score
        fields = ['semester', 'static_lecturer']

    def __init__(self, data=None, queryset=None, *, request=None, prefix=None):
        super().__init__(data=data, queryset=queryset, prefix=prefix)
        if request is not None and request.user.is_authenticated:
            self.filters['static_lecturer'].queryset = Person.objects.filter(type="Academic Staff", department__hod=request.user)

class ScoreFilterDean(filters.FilterSet):
    course = CharFilter(field_name='course__course_code', lookup_expr='icontains', label="Course")
    undergrad = CharFilter(field_name='undergrad__username', lookup_expr='icontains', label="Matric")
    class Meta:
        model = Score
        fields = ['semester', 'static_lecturer']

    def __init__(self, data=None, queryset=None, *, request=None, prefix=None):
        super().__init__(data=data, queryset=queryset, prefix=prefix)
        if request is not None and request.user.is_authenticated:
            self.filters['static_lecturer'].queryset = Person.objects.filter(type="Academic Staff", department__faculty__the_dean=request.user)

def lecturers(self):
    return Person.objects.filter(type="Academic Staff")

class ScoreFilterVC(filters.FilterSet):
    static_lecturer = ModelChoiceFilter(queryset=lecturers, label="Lecturer")
    course = CharFilter(field_name='course__course_code', lookup_expr='icontains', label="Course")
    undergrad = CharFilter(field_name='undergrad__username', lookup_expr='icontains', label="Matric")
    class Meta:
        model = Score
        fields = ['semester', 'static_lecturer']
